<?php

class Meow_WPLR_Sync_Media_Library {

	public function __construct() {
    add_action( 'pre_get_posts', array( $this, 'media_filters' ) );
		add_action( 'restrict_manage_posts', array( $this, 'media_dropdown' ) );
	}

	/*
		INIT
	*/

  function media_filters( $q ) {
    require_once( ABSPATH . 'wp-admin/includes/screen.php' );
    $scr = get_current_screen();
    $folder_id = filter_input( INPUT_GET, 'folder_id', FILTER_SANITIZE_STRING );
    if ( ! $q->is_main_query() || ! is_admin() || (int)$folder_id <= 0 || $scr->base !== 'upload' )
    	return;
		global $wplr;
    $pids = $wplr->get_media_from_collection( $folder_id );
    if ( !empty( $pids ) )
      $q->set( 'post__in', $pids );
    else
      $q->set( 'p', -1 );
  }

  function media_dropdown() {
    $scr = get_current_screen();
    if ( $scr->base !== 'upload' )
			return;
		$wp_parent_folder = null;
		global $wpdb, $wplr;
		$tbl_c = $wpdb->prefix . 'lrsync_collections';
		$collections = $wpdb->get_results( "SELECT * FROM $tbl_c WHERE wp_folder_id IS NULL ORDER BY lr_col_id", OBJECT );
    $folder_id = filter_input( INPUT_GET, 'folder_id', FILTER_SANITIZE_STRING );
    $selected = (int)$folder_id > 0 ? $folder_id : '-1';
		echo '<a class="dashicons-before dashicons-camera" style="top: 5px; position: relative; margin: 5px;"></a>
			<select name="folder_id" id="folder_id" class="postform">
			<option value="-1" selected="selected">All Collections</option>';
		$collections = $wplr->read_collections_recursively();
		foreach ( $collections as $c ) {
			echo '<option class="level-' . $c['level'] . '"' .
				( $c['is_folder'] ? ' disabled' : '' ) . ' value="' .
				$c['wp_col_id'] . '" ' . selected( $c['wp_col_id'], $folder_id ) . '>' .
				str_pad( "", $c['level'] * 6 * 3, "&nbsp;" ) . $c['name'] .
				'</option>';
		}
		echo '</select>';
  }

}

?>
