<?php

class Meow_WPLR_Sync_RPC extends Meow_WPLR_Sync_API {

	public function __construct() {
		add_filter( 'xmlrpc_methods', array( $this, 'init' ) );
		parent::__construct();
	}

	function init( $methods ) {
		foreach ( $this->methods as $m )
			$methods['lrsync.' . $m] = array( $this, $m );
		$methods['lrsync.list'] = array( $this, 'list_sync_media' );
		return $methods;
	}

	// Authenticate and share the useful arguments.
	function init_with( &$args ) {
		global $wp_xmlrpc_server;
		global $wplr;
		$wplr->check_db();
		$wp_xmlrpc_server->escape( $args );
		$blog_id  = array_shift( $args );
		$username = array_shift( $args );
		$password = array_shift( $args );
		$user = wp_authenticate( $username, $password );
    if ( is_wp_error( $user ) ) {
			$message = strip_tags( $user->get_error_message() );
      $this->error = new IXR_Error( 403, $message );
			return false;
    }
		else if ( empty( $user ) ) {
			$this->error = new IXR_Error( 403, __( 'Incorrect username or password.' ) );
			return false;
		}
		wp_set_current_user( $user->ID );
		if ( !current_user_can( 'upload_files' ) ) {
			$this->error = new IXR_Error( 403, __( 'You do not have permission to upload files.' ) );
			return false;
		}
    return get_userdata( $user->ID );
	}

}
